clc
clear
TLD=800;          %Total Load Demand (MW)
Nu=3;            %Number of Units
Pi=zeros(1,Nu);
Fi=zeros(Nu,1);
Pimax=zeros(Nu,1);
Pimin=zeros(Nu,1);
for i=1:Nu
    data_file_name=['unit',num2str(i),'_data.xlsx'];
    T=readtable(data_file_name);
    TA=table2array(T);
    Pi_temp=TA(find(TA(:,1)==TA(1,3)):find(TA(:,1)==TA(1,4)),1);
    Pi(1:size(Pi_temp),i)=Pi_temp;
    Fi_temp=TA(find(TA(:,1)==TA(1,3)):find(TA(:,1)==TA(1,4)),2);
    Fi(1:size(Fi_temp),i)=Fi_temp;
    Pimax(i)=TA(1,3);
    Pimin(i)=TA(1,4);
end
D=sort(unique(Pi(:),'first'));
FD=zeros(size(D,1),Nu);

Pi(Pi==0)=NaN;
Fi(Fi==0)=+inf;

for j=1:Nu
    for i=1:size(D,1)
        temp_index=find(Pi(:,j)==D(i));
        if temp_index>0
            FD(i,j)=Fi(temp_index,j);
        else
            FD(i,j)=inf;
        end
    end
end

Tab=zeros(size(D,1),size(D,1)+2+Nu);
Tab(:,end-Nu-1:end)=NaN;
FDkplus=zeros(Nu,1);

F1map=containers.Map(D,[FD(:,1)]);
F2map=containers.Map(D,[FD(:,2)]);
F3map=containers.Map(D,[FD(:,3)]);
Pc=0;
P_final=zeros(1,Nu);
%% another programm 



%% continue
for i=1:size(D,1)
    d=D(i);
    for j=1:size(D,1)
        Pc=D(j);
        if (d-Pc)<0
            Tab(i,j)=inf;
        else
            Tab(i,j)=F1map(d-Pc)+F2map(Pc);
        end
        if j==1
            min_i=Tab(i,j);
            min_pc=Pc;
        else
            if min_i>Tab(i,j)
                min_i=Tab(i,j);
                min_pc=Pc;
            end
        end
    end
    Tab(i,end-Nu-1)=min_i;
    Tab(i,end-Nu)=min_pc;
    Tab(i,end-Nu+1)=d-min_pc;
    Tab(i,end-Nu+2)=min_pc;
end
%Tab(:,end-1)=min(Tab,[],2);

f2map=containers.Map(D,[Tab(:,end-Nu-1)]);

Tab_new=zeros(size(D,1),size(D,1)+2+Nu);
Tab_new(:,end-Nu-1:end-Nu)=NaN;
for i=1:size(D,1)
    d=D(i);
    for j=1:size(D,1)
        Pc=D(j);
        if (d-Pc)<0
            Tab_new(i,j)=inf;
        else
            Tab_new(i,j)=f2map(d-Pc)+F3map(Pc);
        end
        if j==1
            min_i=Tab_new(i,j);
            min_pc=Pc;
        else
            if min_i>Tab_new(i,j)
                min_i=Tab_new(i,j);
                min_pc=Pc;
            end
        end
    end
    Tab_new(i,end-Nu-1)=min_i;
    Tab_new(i,end-Nu)=min_pc;
end
f3map=containers.Map(D,[Tab_new(:,end-Nu-1)]);
Tab
Tab_new
a=find(D==TLD);
[b1,b2]=find(Tab_new(a,:)==f3map(TLD));
P_final(end)=D(b1);
% a=find(D==TLD-P_final(end));
% [b1,b2]=find(Tab(a,:)==f2map(TLD-P_final(end)));
% P_final(end-1)=D(b1);