clc
clear
close all

TLD=800;          %Total Load Demand (MW)
Nu=3;            %Number of Units
Pi=zeros(1,Nu);
Fi=zeros(Nu,1);
Pimax=zeros(Nu,1);
Pimin=zeros(Nu,1);
for i=1:Nu
    data_file_name=['unit',num2str(i),'_data.xlsx'];
    T=readtable(data_file_name);
    TA=table2array(T);
    Pi_temp=TA(find(TA(:,1)==TA(1,3)):find(TA(:,1)==TA(1,4)),1);
    Pi(1:size(Pi_temp),i)=Pi_temp;
    Fi_temp=TA(find(TA(:,1)==TA(1,3)):find(TA(:,1)==TA(1,4)),2);
    Fi(1:size(Fi_temp),i)=Fi_temp;
    Pimax(i)=TA(1,3);
    Pimin(i)=TA(1,4);
end
D=sort(unique(Pi(:),'first'));
FD=zeros(size(D,1),Nu);

Pi(Pi==0)=NaN;
Fi(Fi==0)=+inf;

for j=1:Nu
    for i=1:size(D,1)
        temp_index=find(Pi(:,j)==D(i));
        if temp_index>0
            FD(i,j)=Fi(temp_index,j);
        else
            FD(i,j)=inf;
        end
    end
end

Tab=zeros(size(D,1),size(D,1)+2+Nu);
Tab(:,end-Nu-1:end)=NaN;
FDkplus=zeros(Nu,1);

F1map=containers.Map(D,[FD(:,1)]);
F2map=containers.Map(D,[FD(:,2)]);
F3map=containers.Map(D,[FD(:,3)]);

figure
min=[inf,inf,inf,inf]; % min=[minCost, minP1, minP2, minP3]
for p1=100:100:500
    for p2=100:100:500
        if ((p1+p2)<=600)
          cost=F1map(p1)+F2map(p2)+F3map(800-(p1+p2));
          plot3(p1,p2,cost,'d')
          hold on
          if cost<min(1)
              min(1)=cost;
              min(2)=p1;
              min(3)=p2;
              min(4)=800-(p1+p2);
          end
        end
    end
end
grid on
axis vis3d;