clc
clear
close all
T1 = readtable('unit1_data.xlsx','PreserveVariableNames',false);
T1A = table2array(T1);
p1i = T1A(find(T1A(:,1)==T1A(1,3)):find(T1A(:,1)==T1A(1,4)),1);
f1i =  T1A(find(T1A(:,1)==T1A(1,3)):find(T1A(:,1)==T1A(1,4)),2);
T2 = readtable('unit2_data.xlsx','PreserveVariableNames',false);
T2A = table2array(T2);
p2i = T2A(find(T2A(:,1)==T2A(1,3)):find(T2A(:,1)==T2A(1,4)) , 1);
f2i =  T2A(find(T2A(:,1)==T2A(1,3)):find(T2A(:,1)==T2A(1,4)),2);
T3 = readtable('unit3_data.xlsx','PreserveVariableNames',false);
T3A = table2array(T3);
p3i = T3A(find(T3A(:,1)==T3A(1,3)):find(T3A(:,1)==T3A(1,4)),1);
f3i =  T3A(find(T3A(:,1)==T3A(1,3)):find(T3A(:,1)==T3A(1,4)),2);

syms f1(p1)
f1(p1) = 0.0003571.*p1.^2 + 4.316.*p1 + 68;
df1=diff(f1,p1);
syms P1(L)
P1(L)=(L-df1(0))/(df1(1)-df1(0));
syms f2(p2)
f2(p2) = -0.0005714.*p2.^2 + 5.143.*p2 - 72;
df2=diff(f2,p2);
syms P2(L)
P2(L)=(L-df2(0))/(df2(1)-df2(0));
syms f3(p3)
f3(p3) = (-9.74e-06).*p3.^2 + 4.46.*p3 + 121.5;
df3=diff(f3,p3);
syms P3(L)
P3(L)=(L-df3(0))/(df3(1)-df3(0));
L1=eval(solve(P1+P2+P3-800));
p1_final=eval(P1(L1))
p2_final=eval(P2(L1))
p3_final=eval(P3(L1))
Ftot=eval(f1(p1_final)+f2(p2_final)+f3(p3_final))
fprintf('-----------------------------\n Evaluating Ftot=f1(0)+f2(0)+f3(800)=')
eval(f1(0)+f2(0)+f3(800))
x=0:20:540;
[X,Y]=meshgrid(x,x);
Z=800-(X+Y);
Z=Z.*heaviside(Z);
ftot3d_2nd=eval(f1(X)+f2(Y)+f3(Z));
%surfl(X,Y,ftot3d_2nd)
%xlabel('P1 (MW)')
%ylabel('P2 (MW)')
%zlabel('Total cost($/h)')

hold off
%figure
clear x
clear y
clear z

      %******              %There was a problem that makes the results wrong

% x=0:10:800;
% [X,Y]=meshgrid(x,x);
% mesh=X+Y;
% X(mesh>800)=NaN;
% Y(mesh>800)=NaN;
% %f=@(x,y) 0.0003571.*x.^2+4.316.*x+68-0.0005714.*y.^2+5.143.*y-72+(-9.74e-06).*((800-(x+y)).*heaviside(800-(x+y))).^2+4.46.*((800-(x+y)).*heaviside(800-(x+y)))+121.5;
% w=f(X,Y);
% surfc(X,Y,w)
% xlabel('P1 (MW)')
% ylabel('P2 (MW)')
% zlabel('Total cost($/h)_2ndOrder')
% hold off
% fprintf('-----------------------------\n Evaluating ftot_min=eval(f1(180)+f2(0)+f3(800-180))=')
% ftot_min=eval(f1(180)+f2(0)+f3(800-180))


figure
       p11 =   3.333e-06  ;
       p21=   -0.002643  ;
       p31 =       5.102 ;
       p41 =          12  ;

       p12 =   3.333e-05  ;
       p22 =    -0.03057  ;
       p32 =       13.01  ;
       p42 =        -632 ;

       p13 =  -1.768e-07  ;
       p23 =   0.0003084 ;
       p33 =        4.29  ;
       p43 =       147.1  ;
f3rd=@(x,y) p11.*x.^3 + p21.*x.^2 + p31.*x + p41 +  p12.*y.^3 + p22.*y.^2 + p32.*y + p42 + p13*(800-(x+y)).^3 + p23.*(800-(x+y)).^2 + p33.*(800-(x+y)) + p43;
w3rd=f3rd(X,Y);
surfc(X,Y,w3rd)
xlabel('P1 (MW)')
ylabel('P2 (MW)')
zlabel('Total cost($/h)_3rdOrder')
hold off

figure
x=0:2.5:800;
[X,Y]=meshgrid(x,x);
mesh=X+Y;
X(mesh>800)=NaN;
Y(mesh>800)=NaN;
X(X<100)=NaN;
Y(Y<100)=NaN;
X(X>500)=NaN;
Y(Y>500)=NaN;
X(mesh>600)=NaN;
Y(mesh>600)=NaN;
w3rd=f3rd(X,Y);
s=surf(X,Y,w3rd);

s.EdgeColor = 'none';

xlabel('P1 (MW)');
ylabel('P2 (MW)');
zlabel('Total cost($/h)_3rdOrder_Upper&Lower Constraints');
axis vis3d;
hold off
fprintf('-----------------------------\n Evaluating ftot_min=eval(f1(187.5)+f2(100)+f3(512.5))=')
ftot_min=eval(f1(187.5)+f2(100)+f3(512.5))

figure
x=0:10:800;
[X,Y]=meshgrid(x,x);
z=800-(X+Y);
w2nd=eval(f1(X)+f2(Y)+f3(z));
mesh=X+Y;
X(mesh>800)=NaN;
Y(mesh>800)=NaN;
X(X<100)=NaN;
Y(Y<100)=NaN;
X(X>500)=NaN;
Y(Y>500)=NaN;
X(mesh>600)=NaN;
Y(mesh>600)=NaN;
s2=surf(X,Y,w2nd);
xlabel('P1 (MW)');
ylabel('P2 (MW)');
zlabel("f1(P1)+f2(P2)+f3(800-(P1+P2)) - 2nd Degree");
axis vis3d;
hold on;
plot3(187.5,100,f1(187.5)+f2(100)+f3(512.5),'d','Color','b','MarkerSize',10,'MarkerFaceColor','#D9FFFF')
%plot3(201.6043,597.6673,f1(201.6043)+f2(597.6673)+f3(0.7284),'d','Color','b','MarkerSize',10,'MarkerFaceColor','#D9FFFF')

L2=eval(solve(P1+P2+200-800));
p1_final_2=eval(P1(L2))
p2_final_2=eval(P2(L2))
Ftot=eval(f1(p1_final_2)+f2(p2_final_2)+f3(200))

%%
% figure
% xtest=0:1:10
% [Xtest,Ytest]=meshgrid(xtest,xtest);
% surf(Xtest,Ytest,ones(11,11))
% %f=@(x,y,z) x+y+z-800
% %interval = [0 800 0 800 0 800];
% %fimplicit3(f)
% 
