clc
clear
close all
%% Reading Data form Tables

T1 = readtable('unit1_data.xlsx','PreserveVariableNames',false);  %Reads Unit_1 Data from Excel file
T1A = table2array(T1);
p1i = T1A(find(T1A(:,1)==T1A(1,3)):find(T1A(:,1)==T1A(1,4)),1);
f1i =  T1A(find(T1A(:,1)==T1A(1,3)):find(T1A(:,1)==T1A(1,4)),2);

T2 = readtable('unit2_data.xlsx','PreserveVariableNames',false);     %Reads Unit_2 Data from Excel file
T2A = table2array(T2);
p2i = T2A(find(T2A(:,1)==T2A(1,3)):find(T2A(:,1)==T2A(1,4)) , 1);
f2i =  T2A(find(T2A(:,1)==T2A(1,3)):find(T2A(:,1)==T2A(1,4)),2);

T3 = readtable('unit3_data.xlsx','PreserveVariableNames',false);     %Reads Unit_3 Data from Excel file
T3A = table2array(T3);
p3i = T3A(find(T3A(:,1)==T3A(1,3)):find(T3A(:,1)==T3A(1,4)),1);
f3i =  T3A(find(T3A(:,1)==T3A(1,3)):find(T3A(:,1)==T3A(1,4)),2);

lb = [p1i(1),p2i(1),p3i(1)];  %Units Lower Bounds
ub = [p1i(end),p2i(end),p3i(end)];  %Units Upper Bounds
%%
% lb=[320,300,275];
% ub=[800,1200,1100];
TLD = 800;  %800%2500Total Load Demad in MW
%% Fitting 3rd-degree polynominal to data points
c(1,:)= polyfit(p1i,f1i,3);     %returns the coefficients for a polynomial Cost Function for Unit_1
c(2,:)= polyfit(p2i,f2i,3);     %returns the coefficients for a polynomial Cost Function for Unit_2
c(3,:)= polyfit(p3i,f3i,3);     %returns the coefficients for a polynomial Cost Function for Unit_3

% c=[1.27e-7  ,   9.68e-4     ,   6.95    ,   749.55
%       6.453e-8  ,   7.375e-4    ,   7.051   ,   1285.0
%       9.98e-8    ,  1.04e-3     ,   6.531   ,   1531.0];

dc=c(:,1:end-1);            %returns the coefficients for the incremental Cost Functions
dc(:,1)=dc(:,1).*3;
dc(:,2)=dc(:,2).*2;
%%
dce=dc; % dce is dc matrix with the last column-λ

N=20;   %N = iteration count limit

n=1;        %n= iteration number
m=size(c,1);            % m=Total nmber of thermal units

lambda=4.46%(4.5065+4.8383+4.4548)/3; %7   %lambda = Lagrange multiplier (Lambda)

lambda_a(1)=lambda;
del_lambda=0;   %del_lamda = change in lambda
e=0.01;     %e = iteration tolerance
P=zeros(1,m);
Psum=0;
Pnet=zeros(1,m);

Pmin=lb;    %Pmin & Pmax = minimum and maximum power limits
Pmax=ub;
PD=TLD;     %PD = Power Demand

while(1)
    dce=dc;
    dce(:,end)=dce(:,end)-lambda.*ones(size(dce(:,end)));
    Psum(n)=0;
    lambda_a(n)=lambda;
    r=zeros(m,2);
    for k=1:m
        r(k,:)=roots(dce(k,:));
        if isreal(r(k,1))
        else
            r(k,1)=inf;
        end
        if isreal(r(k,2))
        else
            r(k,2)=inf;
        end
    end
   indic=[abs(sum(r(:,1))-PD),abs(sum(r(:,2))-PD)];
   indicn=find(indic==min(indic));
   if(max(size(indicn))==2)
       break
   end
   P(n,1:3)=(r(:,indicn))'
   Psum(n)=sum(P(n,:));
%     for k=1:m
%         r=real(roots(dce(k,:)));
%         if r(1)>Pmin(k)
%             P(n,k)=r(1);
%         else
%             P(n,k)=r(2);
%         end
%          Psum(n)= Psum(n)+P(n,k);
%     end
    if n>N
        break
    end
    Pnet(n)=Psum(n)-PD;
    
    if n==1
        if Psum(n)>PD
            lambda=lambda-lambda/1000;
        else
            lambda=lambda+lambda/1000;
        end
    else
        x1=Psum(n-1);
        x2=Psum(n);
        y1=lambda_a(n-1);
        y2=lambda_a(n);
        lambda=(PD-x1)*((y2-y1)/(x2-x1))+y1;
    end
    if abs(Pnet(n))<e
        break
    end
    n=n+1;
end
cnames=["Iteration","λ","Total Generation (MW)","P"];
%string(array2table(P).Properties.VariableNames)
T = table(array2table((1:n)','VariableNames',{'Iteration'}),array2table((lambda_a'),'VariableNames',{'λ'}),array2table((Psum'),'VariableNames',{'Total Generation (MW)'}),array2table(P)).Variables

polyval(c(1,:),P(end,1))+polyval(c(2,:),P(end,2))+polyval(c(3,:),P(end,3))
polyval(c(1,:),400)+polyval(c(2,:),100)+polyval(c(3,:),300)

