function [fitresult, gof] = createFit(p1i, f1i)
%CREATEFIT(P1I,F1I)
%  Create a fit.
%
%  Data for 'untitled fit 1' fit:
%      X Input : p1i
%      Y Output: f1i
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 27-Oct-2022 01:48:05


%% Fit: 'untitled fit 1'.

[xData, yData] = prepareCurveData( p1i, f1i );

% Set up fittype and options.
ft = fittype( 'poly3' );

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft );

% Plot fit with data.
figure( 'Name', 'untitled fit 1' );
h = plot( fitresult, xData, yData );
legend( h, 'f1i vs. p1i', 'untitled fit 1', 'Location', 'NorthEast', 'Interpreter', 'none' );
% Label axes
xlabel( 'p1i', 'Interpreter', 'none' );
ylabel( 'f1i', 'Interpreter', 'none' );
grid on


